{% extends 'base.html' %} {% block content %} {% load static %}
{% load humanize %}
<div class="container">
  <h2 class="">
    Keranjang Belanja
  </h2>
  <div class="row mt-3">
    {% if keranjang %}
        <table class="table table-striped">
        <thead>
            <tr>
            <th scope="col">Barang</th>
            <th scope="col">Qty</th>
            <th scope="col">Harga</th>
            </tr>
        </thead>
        <tbody>
        {% for barang in keranjang.entry.all %}
        <tr>
        <td>{{barang.barang.nama}}</td>
        <td>{{barang.jumlah}}
        </td>
        <td>Rp. {{barang.harga_total|intcomma}}</td>
        </tr>
        {% endfor %}
        </tbody>
        <tfoot>
            <tr>
                <td colspan="2"><strong>Kupon</strong> (<i>contoh: '<40' atau '>50'</40></i>)</td>
                <td><select id="kupon" tabindex="1" style="width: 75%;"><option></option></select></td>
            </tr>
            <tr>
                <td colspan="2"><strong>Total</strong></td>
                <td colspan="1">Rp. <span id="total-price">{{keranjang.total|intcomma}}</span></td>
            </tr>
        </tfoot>
        </table>
        <button class="btn btn-info" id="btn-buy">Beli</button>
    {% else %}
    Keranjang Belanja anda kosong!
    {% endif %}
  </div>
</div>

{% load static %} {% endblock %} {% block head %}
<title>Keranjang | Tk.PePeW Online Shop</title>
<link rel="stylesheet" href="https://unpkg.com/swiper/css/swiper.min.css" />

{% endblock %}
{% block js %}
<script>
    let kupons;
    const total = Number(`{{keranjang.total}}`.replace(',', '.'));
    let totald = total;
    let kuponid;
    async function initialize() {
        const source = await fetch(`{% url 'kupon:kupon-api' %}`);
        const data = await source.json();
        kupons = data.kupons.map((k) => {
            return {
                ...k,
                text: k.kode
            }
        })

        $("#kupon").select2({
            placeholder: 'Cari Kupon',
            allowClear: true,
            data: kupons,
            templateResult: (state) => {
                return `${state.text} | ${state.persen_diskon}%`
            },
            matcher: matcher
        });
    }

    function matcher(params, data) {
        // If there are no search terms, return all of the data
        if ($.trim(params.term) === '') {
            return data;
        }

        // Do not display the item if there is no 'text' property
        if (typeof data.text === 'undefined') {
            return null;
        }

        // add matcher for <40 and >40
        const r = (/^>(\d+)/.exec(params.term))
        const m1 = r ? r[1] : null;
        if (m1) {
            return Number(data.persen_diskon) > Number(m1) ? data : null;
        }

        const r2 = (/<(\d+)/.exec(params.term))
        const m2 = r2 ? r2[1] : null;
        if (m2) {
            return Number(data.persen_diskon) < Number(m2) ? data : null;
        }

        if (data.text.toLowerCase().includes(params.term.toLowerCase())) {
            return data;
        }

        return null;
    }

    $(function() {
        initialize();

        $("#kupon").on("select2:select", (e) => {
            const d = e.params.data;
            if (total > d.min_harga){
                totald = total * (100 - Number(d.persen_diskon))/100;
                $("#total-price").text(totald.toLocaleString());
                kuponid = d.id;
            }
            else{
                alert("Total Harga Belum Mencapai Minimal !")
            }
        })

        $("#btn-buy").click(async () => {
            const csrftoken = Cookies.get('csrftoken');

            const notyf = new Notyf({
                types: [
                    {
                    type: 'info',
                    background: 'orange',
                    icon: false
                    }
                ]
            });

            notyf.open({
                type: 'info',
                message: `Sedang membuat transaksi!`
            })

            const data = {
                total_harga: totald,
                kupon_id: kuponid
            }

            const response = await fetch(`{% url 'transaksi:beli-cepat' %}`, {
                method: 'POST',
                body: JSON.stringify(data),
                headers: { "X-CSRFToken": csrftoken },
            });

            const result = await response.json();

            notyf.dismissAll();

            if (result.success) {
                notyf.success(`Sukses membuat Transaksi! Redirect dalam 5 detik!`);
                setTimeout(function(){
                    window.location.href = `{% url 'transaksi:riwayat-cepat'%}`;
                }, 5000);
            } else {
                notyf.error(`Gagal membuat Transakasi!`);
                notyf.error(result.error);
            }
        });
    });
</script>
{% endblock%}